#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<stdbool.h>
#include	<sys/stat.h>
#include	</usr/include/usb.h>
#include	"SUP.h"
#include	"BitSwap.h"

//	----------------------------------------------------------------------------------------------------------------
//	ڼ޽֐
//		֐								mF
//		SUP_Reg_Write						2020.06.01
//		SUP_Reg_Read						2020.06.01
//		SUP_Reg_WriteEx						2020.06.03
//		SUP_Reg_ReadEx						2020.06.03
//
//	----------------------------------------------------------------------------------------------------------------
//  ްذ/ײĊ֐
//		֐								mF
//		SUP_Data_Write						2020.06.01		CX-Card2X@1MB
//		SUP_Data_Read						2020.06.01		CX-Card2X@1MB
//		SUP_Mem_Cmd							2020.06.01
//	----------------------------------------------------------------------------------------------------------------
//	հèè֐
//		֐								mF
//		SUP_Get_BoardInfo					2020.05.28
//		SUP_Usb_Config						2020.06.03		Encrypt߼݂͖mF
//		SUP_I2c_Read						2020.06.03
//		SUP_I2c_Write						2020.06.03
//		SUP_Get_FPGA_Temp					2020.06.03
//		SUP_Suspend							2020.06.03
//		SUP_GPIO_Dir						2020.06.03		@ł͖mF
//		SUP_GPIO_Read						2020.06.03		@ł͖mF
//		SUP_GPIO_Write						2020.06.03		@ł͖mF
//		SUP_GPIF_Set_Wave					
//		SUP_GPIF_Reg_Wait					
//		SUP_Usb_Deconfig					2020.06.02
//		SUP_Reg_Burst_Write					2020.06.03		@ł͖mF
//		SUP_Reg_WriteExIO2					2020.06.03		@ł͖mF
//		VIEW_BoardInfo						2020.05.28
//	----------------------------------------------------------------------------------------------------------------


//	----------------------------------------------------------------------------------------------------------------
//	USBڼ޽ײ
//
//  
//  adrs    :   0`16383͈̔͂ޯڼ޽̱ڽw肷
//  range   :   SUPlv_RANGE8BIT/16BIT/32BIT/64BITw肷
//  wd      :   ײްw肷
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Reg_Write( usb_dev_handle *handle, unsigned short adrs, unsigned char range, unsigned long long wd )
{
	int						sts;
	unsigned short			length;
	unsigned short			value;
	unsigned char			control_msg[8];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//  ݸ޽mF
	//  8ޯ
	if( range == SUP_RANGE_8BIT )
	{
		length = 1;
		wd &= 0xFF;
	}

	//  16ޯ
	if( range == SUP_RANGE_16BIT )
	{
		length = 2;
		wd &= 0xFFFF;
	}

	//  32ޯ
	if( range == SUP_RANGE_32BIT )
	{
		length = 4;
		wd &= 0xFFFFFFFF;
	}

	//  64ޯ
	if( range == SUP_RANGE_64BIT )
	{
		length = 8;
		wd &= 0xFFFFFFFFFFFFFFFF;
	}

	*(( unsigned long long * ) control_msg ) = wd;

	//	ڼ޽(ڼ޽8ޯ+ڼ޽+ڼ޽ڽ6ޯ)
	value = (( adrs & SUP_ADRS_HIGH_MASK ) << 2 ) | ( adrs & SUP_ADRS_LOW_MASK ) | ( range & SUP_RANGE_MASK );

	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REGISTER,								//	INT		REQUEST
							value,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							length,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != length )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_REGISTER, control_msg[0] );
		return false;
	}

	return	true;
}
//	---------------------------------------------------------------------------
//  USBڼ޽ذ
//
//  
//  adrs    :   0`16383͈̔͂ޯڼ޽̱ڽw肷
//  range   :   SUPlv_RANGE8BIT/16BIT/32BIT/64BITw肷
//  rd      :   ذް߲w肷
//	---------------------------------------------------------------------------
bool	SUP_Reg_Read( usb_dev_handle *handle, unsigned short adrs, unsigned char range, unsigned long long *rd )
{

	int						sts;
	unsigned short			length;
	unsigned short			value;
	unsigned char			control_msg[8];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//  ݸ޽mF
	//  8ޯ
	if( range == SUP_RANGE_8BIT )
	{
		length = 1;
	}

	//  16ޯ
	if( range == SUP_RANGE_16BIT )
	{
		length = 2;
	}

	//  32ޯ
	if( range == SUP_RANGE_32BIT )
	{
		length = 4;
	}

	//  64ޯ
	if( range == SUP_RANGE_64BIT )
	{
		length = 8;
	}

	//	ڼ޽(ڼ޽8ޯ+ڼ޽+ڼ޽ڽ6ޯ)
	value = (( adrs & SUP_ADRS_HIGH_MASK ) << 2 ) | ( adrs & SUP_ADRS_LOW_MASK ) | ( range & SUP_RANGE_MASK );

	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REGISTER,								//	INT		REQUEST
							value,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							length,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != length )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_REGISTER, control_msg[0] );
		return false;
	}

	//  ݸ޽mF
	//  8ޯ
	if( range == SUP_RANGE_8BIT )
	{
	   *rd = ( *(( unsigned long long * ) control_msg )) & 0x000000FF;
	}

	//  16ޯ
	if( range == SUP_RANGE_16BIT )
	{
	   *rd = ( *(( unsigned long long * ) control_msg )) & 0x0000FFFF;
	}

	//  32ޯ
	if( range == SUP_RANGE_32BIT )
	{
	   *rd = ( *(( unsigned long long * ) control_msg )) & 0xFFFFFFFF;
	}

	//  64ޯ
	if( range == SUP_RANGE_64BIT )
	{
	   *rd = ( *(( unsigned long long * ) control_msg )) & 0xFFFFFFFFFFFFFFFF;
	}



	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	USBڼ޽ײEX
//
//  
//  adrs    :   0`1023͈̔͂ޯڼ޽̱ڽw肷
//  range   :   ײĂް޲Đ1`64Ŏw肷
//  wd      :   ײްw肷
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Reg_WriteEx( usb_dev_handle *handle, unsigned short adrs, unsigned char size, unsigned char *wd )
{
	int				sts;
	unsigned short	length;
	unsigned short	value;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	if( size == 0 )
	{
		return	false;
	}

	//	ڼ޽
	//	6ޯĂݸ޽(0`63)
	//	10ޯĂڼ޽ڽ(0`1023)
	length = size - 1;
	length &= 0x003F;
	value = (( length << 10 ) | adrs ) & 0xFFFF;

	//	-----------------------------------------------------------------------
	//	USBڼ޽ײEXޔs
	//	ظ(C6h)
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REGISTER_EX,								//	INT		REQUEST
							value,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							&wd[0],														//	CHAR*	MSG
							( size & 0xFFFF ),											//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_REGISTER_EX, wd[0] );
		return false;
	}

	//	ڼ޽ײĊҋ@
	//	FX2FPGAւްo͂ő200usKvȂ̂ł̊Ԃ͑ҋ@B
	//	̑ҋ@Ԃ폜̧ѳۯ̂ō폜ȂB
	usleep( 200 );

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	USBڼ޽ذEX
//
//  
//  adrs    :   0`1023͈̔͂ޯڼ޽̱ڽw肷
//  range   :   ذން޲Đ1`64Ŏw肷
//  rd      :   ذްw肷
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Reg_ReadEx( usb_dev_handle *handle, unsigned short adrs, unsigned char size, unsigned char *rd )
{
	int				sts;
	unsigned short	length;
	unsigned short	value;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	if( size == 0 )
	{
		return	false;
	}

	//	ڼ޽
	//	6ޯĂݸ޽(0`63)
	//	10ޯĂڼ޽ڽ(0`1023)
	length = size - 1;
	length &= 0x003F;
	value = (( length << 10 ) | adrs ) & 0xFFFF;

	//	-----------------------------------------------------------------------
	//	USBڼ޽ײEXޔs
	//	ظ(C6h)
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REGISTER_EX,								//	INT		REQUEST
							value,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							&rd[0],														//	CHAR*	MSG
							( size & 0xFFFF ),											//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_REGISTER_EX, rd[0] );
		return false;
	}

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	USB̨ފ֐
//
//	Ӱ޵߼݁
//	FPGA޲[J
//	Xilinx/INTEL
//	
//	
//	BITSWAP߼݁
//	XILINX޲̵߼
//	BITSWAP߼݂w肳BYTEMSBLSB̓ւsB
//	ׂ̈ɗ\ߍ쐬ðق𗘗pĂB
//
//	Encrypt߼݁
//	XILINX޲̵߼݂ňÍ@\߰ĂĂްތ
//
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Usb_Config( usb_dev_handle *handle, char *filename, bool mode, bool swap, bool encrypt )
{
	unsigned int			i;
	int						sts;
	unsigned char			control_msg[64];

	FILE					*fp;
	struct					stat	file_stat;
	unsigned int			lFileSize;
	unsigned int			offset;
	unsigned int			lConfigSize;

	unsigned char			*pBuffer;
	unsigned int			*pdBuffer;

	unsigned char			*pConfig;
	unsigned int			*pdConfig;

	unsigned int			amari;
	unsigned int			num;
	unsigned char			tmp;

	int						cmd_size;
	unsigned long long		cfg_sts;


	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	USB̨ފJnޔs
	//	ظ(B2h)
	cmd_size = 1;
	control_msg[0] = SUP_USBCONFIG_START;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_USBCONFIG,								//	INT		REQUEST
							0x0000,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							cmd_size,													//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != cmd_size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_USBCONFIG, control_msg[0] );
		return false;
	}

	//	-----------------------------------------------------------------------
	//  ̨̧ٵݏ
	if( fp = fopen( filename, "rb"))
	{
		//	̧ٻގ擾
		stat( filename, &file_stat );
		lFileSize = file_stat.st_size;
		printf("Configuration File = %s\n", filename );
		printf("Configuration size %d Bytes\n", lFileSize );

		//  Xilinx޲łDONEҋ@аްǉ
		//  ̨ڰ(16MHz)~ޯĕ(16Bit)~ҋ@(2ms) = 64KBytes
		if( mode == SUP_CONFIG_MODE_XILINX )
		{
			offset = SUP_DONE_WAIT_SIZE;
		}
		else
		{
			offset = 0;
		}

		//	Encrypt߼݂̏ꍇ̧ٻނ2{ɂ؂mۂ
		if( encrypt )
		{
			lConfigSize = ( lFileSize * 2) + offset;
		}
		else
		{
			lConfigSize = lFileSize + offset;
		}

		//	̧ذޗp؊m
		pBuffer = ( unsigned char * )malloc( lFileSize + offset );
		if( pBuffer == NULL )
		{
			printf("pBuffer malloc error!!\n");
			fclose( fp );
			return false;
		}

		//	̨ްWJp؊m
		pConfig = ( unsigned char * )malloc( lConfigSize );
		if( pConfig == NULL )
		{
			printf("pConfig malloc error!!\n");
			free( pBuffer );
			fclose( fp );
			return false;
		}

		pdBuffer = ( unsigned int * )( pBuffer );
		pdConfig = ( unsigned int * )( pConfig );

		//	̨̧ق̓ǂݍ
		if( fread( pBuffer, 1, lFileSize, fp ) != lFileSize )
		{
			//	ǂݏos
			fclose( fp );
			free( pBuffer );
			free( pConfig );
			return false;
		}
		fclose( fp );

		//	̨ްFFh̨ق
		for(i=0;i<lConfigSize;++i)
		{
			pConfig[i] = 0xFF;
		}
	}

	//	-----------------------------------------------------------------------
	//	Encrypt
	if( encrypt )
	{
		printf("ENCRYPT = ENABLE!!\n");
		//	8ޯӰނSlaveSelectMAPӰނgpׁA
		//	GPIF޽ް޽8ޯĂɂްꂸɉʑްo͂B
		for(i=0;i<(lFileSize);++i)
		{
			pConfig[i*2+0] = pBuffer[i];
			pConfig[i*2+1] = 0x00;
		}
	}
	else
	{
		//	EncryptȂ
		//	̂܂ܺ߰
		printf("ENCRYPT = DISABLE!!\n");
		for(i=0;i<lFileSize;++i)
		{
			pConfig[i] = pBuffer[i];
		}
	}

	//	-----------------------------------------------------------------------
	//	̨Ӱ
	//  Xilinx޲łδިݕϊs
	//	AEncrypt߼݂Lȏꍇɂʹިݕϊ͍sȂB
	if( mode == SUP_CONFIG_MODE_XILINX )
	{
		printf("MODE = XILINX\n");
	
		if( !encrypt )
		{
			//  ̧ٻނł+1
			if(( lFileSize + offset ) % 2 )
			{
				++lFileSize;
			}

			//  ъ
			for(i=0;i<lConfigSize;i=i+2)
			{
				tmp = pConfig[i+0];
				pConfig[i+0] = pConfig[i+1];
				pConfig[i+1] = tmp;
			}
		}
	}
	else
	{
		printf("MODE = INTEL\n");
	}	//	-------------------------------------------------------------------

	//	-----------------------------------------------------------------------
	//	BITSWAP
	if( swap )
	{
		printf("BITSWAP = ENABLE!!\n");
		for(i=0;i<lConfigSize;++i)
		{
			tmp = SWAP[pConfig[i]];
			pConfig[i] = tmp;
		}
	}
	else
	{
		printf("BITSWAP = DISABLE!!\n");
	}

	amari = lConfigSize % BULK_TRANS_MAX;
	num = lConfigSize / BULK_TRANS_MAX;

	//	-----------------------------------------------------------------------
	//	PROGnINITnHIGHɂȂ܂ł̒x
	//	{INITnقĎKv邪Ԃ2{Ƃ鎖őƂ
	usleep( 1000 );

	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_OUT_START, SUP_RANGE_8BIT ))
	{
		free( pBuffer );
		free( pConfig );
		return	false;
	}

	//	-----------------------------------------------------------------------
	printf("Configure ");
	fflush( stdout );

	for(i=0;i<num;++i)
	{
		fflush( stdout );

		if( usb_bulk_write( handle, 0x06,  &pConfig[i*BULK_TRANS_MAX], BULK_TRANS_MAX, USB_TIME_OUT ) != BULK_TRANS_MAX )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			free( pConfig );
			return false;
		}
	}

	if( amari )
	{
		fflush( stdout );
		if( usb_bulk_write( handle, 0x06, &pConfig[num*BULK_TRANS_MAX], amari, USB_TIME_OUT ) != amari )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			free( pConfig );
			return false;
		}
	}

	free( pBuffer );
	free( pConfig );

	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_OUT_END, SUP_RANGE_8BIT ))
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	USB̨޽ð̊mF
	if( !SUP_Reg_Read( handle, SUP_CFG_STS_ADRS, SUP_RANGE_8BIT, &cfg_sts ))
	{
		return	false;
	}

	usleep( 1000 );

	//	-----------------------------------------------------------------------
	//	USB̨ޏIޔs
	//	ظ(B2h)
	cmd_size = 1;
	control_msg[0] = SUP_USBCONFIG_END;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_USBCONFIG,								//	INT		REQUEST
							0x0000,														//	UCHAR	VALUE
							0x0000,														//	USHORT	INDEX
							control_msg,												//	CHAR*	MSG
							cmd_size,													//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != cmd_size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_USBCONFIG, control_msg[0] );
		return false;
	}

	//  ̨޽ð̊mF
	if(( cfg_sts & 0xFF ) == SUP_CFG_STATUS_SUCCESS )
	{
		return  true;
	}

	return	false;
}
//	----------------------------------------------------------------------------------------------------------------
//  ްײĊ֐
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Data_Write( usb_dev_handle *handle, char *filename, unsigned int length, unsigned char range )
{
	FILE					*fp;
	struct					stat	file_stat;
	unsigned char			*pBuffer;
	unsigned int			*pdBuffer;

	unsigned int			i;
	unsigned int			num;
	unsigned int			amari;

	unsigned int			lFileSize;
	unsigned int			lReadSize;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//  ް̧ٵݏ
	if( fp = fopen( filename, "rb"))
	{
		//	̧ٻގ擾
		stat( filename, &file_stat );
		lFileSize = file_stat.st_size;

		//	؊m
		pBuffer = ( unsigned char * )malloc( length );
		if( pBuffer == NULL )
		{
			printf("pBuffer malloc error!!\n");
			return false;
		}

		pdBuffer = ( unsigned int * )( pBuffer );

		//	ޯ̧00h̨ق
		for(i=0;i<(length/4);++i)
		{
			pdBuffer[i] = 0x00000000;
		}

		//	ذނ̧ٻނ̊mF
		if( length > lFileSize )
		{
			//	w肳ꂽײĂ̻ން̧قꍇ
			lReadSize = lFileSize;
		}
		else
		{
			//	w肳ꂽײĂ̻ން̧ق傫Aꍇ
			lReadSize = length;
		}

		//	޲ް̧ق̓ǂݍ
		if( fread( pBuffer, 1, lReadSize, fp ) != lReadSize )
		{
			//	ǂݏos
			fclose( fp );
			free( pBuffer );
			return false;
		}
		fclose( fp );

		amari = length % BULK_TRANS_MAX;
		num = length / BULK_TRANS_MAX;
	}

	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_OUT_START, range ))
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	printf("MemWrite ");
	fflush( stdout );

	for(i=0;i<num;++i)
	{
		printf(".");
		fflush( stdout );

		if( usb_bulk_write( handle, 0x06,  &pBuffer[i*BULK_TRANS_MAX], BULK_TRANS_MAX, USB_TIME_OUT ) != BULK_TRANS_MAX )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			return false;
		}
	}

	if( amari )
	{
		printf(".");
		fflush( stdout );
		if( usb_bulk_write( handle, 0x06, &pBuffer[num*BULK_TRANS_MAX], amari, USB_TIME_OUT ) != amari )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			return false;
		}
	}
	free( pBuffer );

	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_OUT_END, range ))
	{
		return	false;
	}

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//  ްذފ֐
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Data_Read( usb_dev_handle *handle, char *filename, unsigned int length, unsigned char range )
{
	FILE					*fp;
	unsigned char			*pBuffer;

	unsigned int			i;
	unsigned int			num;
	unsigned int			amari;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	؊m
	pBuffer = ( unsigned char * )malloc( length );
	if( pBuffer == NULL )
	{
		printf("pBuffer malloc error!!\n");
		return false;
	}

	amari = length % BULK_TRANS_MAX;
	num = length / BULK_TRANS_MAX;


	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_IN_START, range ))
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	printf("MemRead ");
	fflush( stdout );

	for(i=0;i<num;++i)
	{
		printf(".");
		fflush( stdout );

		if( usb_bulk_read( handle, 0x82,  &pBuffer[i*BULK_TRANS_MAX], BULK_TRANS_MAX, USB_TIME_OUT ) != BULK_TRANS_MAX )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			return false;
		}
	}

	if( amari )
	{
		printf(".");
		fflush( stdout );
		if( usb_bulk_read( handle, 0x82, &pBuffer[num*BULK_TRANS_MAX], amari, USB_TIME_OUT ) != amari )
		{
			printf("transfer error!!\n");
			free( pBuffer );
			return false;
		}
	}

	//	-----------------------------------------------------------------------
	//	Smart-USB PlusӰ
	//	ظ(B1h)
	if( !SUP_Mem_Cmd( handle, SUP_DATA_TRANS_IN_END, range ))
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	ذންw̧قɕۑ
	if( fp = fopen( filename, "wb"))
	{
		if( fwrite( pBuffer, sizeof( unsigned char ), length, fp ) != length )
		{
			printf("fwrite error!!\n");
			fclose( fp );
			return false;
		}
	}
	else
	{
		printf("fopen error!!\n");
		return false;
	}
	fclose( fp );
	free( pBuffer );

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	----------------------------------------------------------------------------------------------------------------

//	---------------------------------------------------------------------------
//	غޔs
//
//	cmd			OUT/IN,START/ENDw肷B
//	range		޽w肷B
//	---------------------------------------------------------------------------
bool	SUP_Mem_Cmd( usb_dev_handle *handle, unsigned char MemCmd, unsigned char range )
{
	unsigned char			control_msg[64];
	int						size;
	int						sts;

	//	-----------------------------------------------------------------------
	//	ް]ޔs
	//	ظ(A1h)
	size = 1;
	control_msg[0] = MemCmd;

	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_DATA,									//	INT		REQUEST
							( range & 0x00FF ),											//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_DATA, 0 );
		return false;
	}

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	eްޏ̎擾
//
//  SelɎ擾ݒ肷B
//
//  0x00C0 : ̧ѳްޮ
//  0x0080 : ޼ޮ
//  0x0040 : ޸ID
//  0x0000 : ڑ߰
//	---------------------------------------------------------------------------
bool	SUP_Get_BoardInfo( usb_dev_handle *handle, unsigned short sel, unsigned short *id )
{
	int				sts;
	int				size = 2;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_BOARDINFO,								//	INT		REQUEST
							( sel & 0x00FF ),											//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_BOARDINFO, control_msg[0] );
		return false;
	}

	*id = ( *(( unsigned short * ) control_msg )) & 0xFFFF;
	return	true;
}
//	---------------------------------------------------------------------------
//  USB޺̨
//	---------------------------------------------------------------------------
bool	SUP_Usb_Deconfig( usb_dev_handle *handle )
{

	unsigned int			i;
	int						sts;
	unsigned char			control_msg[64];
	int						cmd_size;
	unsigned long long		cfg_sts;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	USB̨ފJnޔs
	//	ظ(B2h)
	cmd_size = 1;
	control_msg[0] = SUP_USBCONFIG_START;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_USBCONFIG,								//	INT		REQUEST
							0x0000,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							cmd_size,													//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != cmd_size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_USBCONFIG, control_msg[0] );
		return false;
	}

	usleep( 1000 );		//	usP

	//	-----------------------------------------------------------------------
	//  USB̨޽ð̊mF
	//  ڼ޽2(8ޯı)
	if( !SUP_Reg_Read( handle, SUP_CFG_STS_ADRS, SUP_RANGE_8BIT, &cfg_sts ))
	{
	   return  false;
	}

	usleep( 1000 );		//	usP

	//	-----------------------------------------------------------------------
	//	USB̨ޏIޔs
	//	ظ(B2h)
	cmd_size = 1;
	control_msg[0] = SUP_USBCONFIG_END;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_USBCONFIG,								//	INT		REQUEST
							0x0000,														//	UCHAR	VALUE
							0x0000,														//	USHORT	INDEX
							control_msg,												//	CHAR*	MSG
							cmd_size,													//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != cmd_size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_USBCONFIG, control_msg[0] );
		return false;
	}

	//  ̨޽ð̊mF
	if(( cfg_sts & 0xFF ) != SUP_CFG_STATUS_SUCCESS )
	{
		return  true;
	}

	return	false;
}
//	---------------------------------------------------------------------------
//  I2Cڼ޽ذފ֐
//	---------------------------------------------------------------------------
bool	SUP_I2c_Read( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char *Rd )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	I2C̪ذ޺ޔs
	//	ظ(C1h)
	size = 2;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_I2CREAD,									//	INT		REQUEST
							( DevAdrs & 0x00FF ),										//	U16		VALUE
							( RegAdrs & 0x00FF ),										//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_I2CREAD, control_msg[0] );
		return false;
	}

	//	I2Cذނ?
	if( control_msg[0] == 0x00 )
	{
		return	false;
	}

	*Rd = control_msg[1];
	return	true;
}
//	---------------------------------------------------------------------------
//  I2Cڼ޽ײĊ֐
//	---------------------------------------------------------------------------
bool	SUP_I2c_Write( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char Wd )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	I2C̪ײĺޔs
	//	ظ(C0h)
	size = 1;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_I2CWRITE,								//	INT		REQUEST
							( DevAdrs & 0x00FF ),										//	U16		VALUE
							( Wd << 8 ) | ( RegAdrs & 0x00FF ),							//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_I2CWRITE, control_msg[0] );
		return false;
	}

	//	I2CײĂ?
	if( control_msg[0] == 0x00 )
	{
		return	false;
	}

	return	true;
}
//	---------------------------------------------------------------------------
//  FPGAx擾
//	---------------------------------------------------------------------------
bool	SUP_Get_FPGA_Temp( usb_dev_handle *handle, unsigned short sel, unsigned short  *temp )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	FPGAx擾ޔs
	//	ظ(C2h)
	size = 2;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_GETTEMP,									//	INT		REQUEST
							sel,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X) error!!\n\n", SUP_VENDER_REQUEST_GETTEMP );
		return false;
	}

	*temp = control_msg[0] | ( control_msg[1] << 8 );
	return	true;
}
//	---------------------------------------------------------------------------
//  Ӱސ؂芷
//
//	mode = 1  Ӱނɐ؂ւ
//	mode = 0  ɰӰނɐ؂ւ
//	---------------------------------------------------------------------------
bool	SUP_Suspend( usb_dev_handle *handle, unsigned short mode )
{
	int				sts;
	int				size = 0;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	Ӱސ؂芷ޔs
	//	ظ(C4h)
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_SUSPEND,									//	INT		REQUEST
							mode,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							NULL,														//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X) error!!\n\n", SUP_VENDER_REQUEST_SUSPEND );
		return false;
	}

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	Smart-IO2ްސp@ڼ޽ްײ
//
//	ظĺނUSB̨ޢSUP64_Usb_Config()ƓȂ̂ŁASmart-IO2ްވȊOł͎gpȂ!!
//	
//	adrs(0`63)
//	length(1`64޲)
//	Wd(ײް)
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Reg_Burst_Write( usb_dev_handle *handle, unsigned char adrs, unsigned char length, unsigned char *Wd )
{
	int				sts;
	int				size;

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	ݸ޽(1`64޲)
	if(( length == 0 ) | ( length > 64 ))
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	ڼ޽ްײĺޔs
	//	ظ(B2h)
	size = ( length & 0x00FF );
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REG_BURST_WRITE,							//	INT		REQUEST
							( adrs & 0x003F ),											//	U16		VALUE
							0x0000,														//	U16		INDEX
							&Wd[0],														//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	return	true;
}
//	----------------------------------------------------------------------------------------------------------------
//	USBڼ޽ײEX Smart-IO2ްސp
//
//  
//  adrs    :   0`63͈̔͂ޯڼ޽̱ڽw肷
//  wd      :   ײްw肷
//	----------------------------------------------------------------------------------------------------------------
bool	SUP_Reg_WriteExIO2( usb_dev_handle *handle, unsigned char adrs, unsigned char wd )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	control_msg[0] = wd;

	//	-----------------------------------------------------------------------
	//	ڼ޽ްײĺޔs
	//	ظ(B2h)
	size = 0;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_REG_WRITE_EXIO2,							//	INT		REQUEST
							adrs & 0x003F,												//	U16		VALUE
							wd & 0x00FF,												//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	//	ڼ޽ײĊҋ@
	//	FX2FPGAւްo͂ő200usKvȂ̂ł̊Ԃ͑ҋ@B
	//	̑ҋ@Ԃ폜̧ѳۯ̂ō폜ȂB
	usleep( 200 );

	return	true;
}
//	---------------------------------------------------------------------------
//  GPIO - DIR؂芷
//
//	PortA	 0
//	PortC	 1
//	PortE	 2
//
//	IN		 0
//	OUT		 1
//	---------------------------------------------------------------------------
bool	SUP_GPIO_Dir( usb_dev_handle *handle, unsigned short port, unsigned short dir )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	GPIO-DIR؂芷ޔs
	//	ظ(B4h)
	size = 0;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_GPIODIR,									//	INT		REQUEST
							port,														//	U16		VALUE
							dir,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_GPIODIR, control_msg[0] );
		return false;
	}

	return	true;
}
//	---------------------------------------------------------------------------
//  GPIO - Read
//
//	PortA	 0
//	PortC	 1
//	PortE	 2
//	---------------------------------------------------------------------------
bool	SUP_GPIO_Read( usb_dev_handle *handle, unsigned short port, unsigned char *Rd )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	GPIO-Readޔs
	//	ظ(B6h)
	size = 1;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_IN | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_GPIOREAD,								//	INT		REQUEST
							port,														//	U16		VALUE
							0x0000,														//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_GPIOREAD, control_msg[0] );
		return false;
	}

	//	I2Cذނ?
	if( control_msg[0] == 0x00 )
	{
		return	false;
	}

	*Rd = control_msg[0];
	return	true;
}
//	---------------------------------------------------------------------------
//  GPIO - Write
//
//	PortA	 0
//	PortC	 1
//	PortE	 2
//	---------------------------------------------------------------------------
bool	SUP_GPIO_Write( usb_dev_handle *handle, unsigned short port, unsigned char Wd )
{
	int				sts;
	int				size;
	unsigned char	control_msg[64];

	//	݂Ă޲̗LmF
	if( handle == NULL )
	{
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	GPIO-Writeޔs
	//	ظ(B5h)
	size = 0;
	sts = usb_control_msg(	handle,														//	STRUCT	USB DEVICE
							USB_TYPE_VENDOR | USB_ENDPOINT_OUT | USB_RECIP_DEVICE,		//	INT		REQUEST_TYPE
							SUP_VENDER_REQUEST_GPIOWRITE,								//	INT		REQUEST
							port,														//	U16		VALUE
							Wd,															//	U16		INDEX
							control_msg,												//	CHAR*	MSG
							size,														//	INT		SIZE
							USB_TIME_OUT												//	INT		TIMEOUT
						 );

	if( sts != size )
	{
		printf("usb_control_msg(%02X:%02X) error!!\n\n", SUP_VENDER_REQUEST_GPIOWRITE, control_msg[0] );
		return false;
	}

	return	true;
}
//	---------------------------------------------------------------------------
//	ްޏ擾ĺݿقɏo͂
//	---------------------------------------------------------------------------
bool	VIEW_BoardInfo( usb_dev_handle *handle )
{
	unsigned short	id;
	unsigned short	api[4];

	//	PID̕\
	if( !SUP_Get_BoardInfo( handle, SUP_BOARDINFO_PID, &id ))
	{
		printf("SUP_Get_BoardInfo(PID) failed!!\n\n");
		return	false;
	}
	printf("PID:%04Xh SUP Device Found!!\n", id );

	//	ڑ߰ނ̕\
	if( !SUP_Get_BoardInfo( handle, SUP_BOARDINFO_SPEED, &id ))
	{
		printf("SUS_Get_BoardInfo(SPEED) failed!!\n\n");
		return	false;
	}
	else
	{
		//	ڑ߰ނ\
		switch( id )
		{
			case    SUP_FULL_SPEED:		//  FULL Speed
										printf("SPEED:FullSpeed\n");
										break;

			case    SUP_HIGH_SPEED:		//  HIGH Speed
										printf("SPEED:HighSpeed\n");
										break;

			default:					//	??
										printf("SPEED:Unknown(%02Xh)\n", id );
		}
	}

	//	̧ްޮ
	if( !SUP_Get_BoardInfo( handle, SUP_BOARDINFO_FIRMID, &id ))
	{
		printf("SUP_Get_BoardInfo(FIRMID) failed!!\n\n");
		return	false;
	}
	printf("FIRMID:%04Xh\n", id );

	//	޼ޮ
	if( !SUP_Get_BoardInfo( handle, SUP_BOARDINFO_CHIPVER, &id ))
	{
		printf("SUP_Get_BoardInfo(CHIPVER) failed!!\n\n");
		return	false;
	}
	printf("CHIPVER:%04Xh\n", id );

	return	true;
}
