//	----------------------------------------------------------------------------------------------------------------
//	SUP޲plibusbٿĳ USB̨ڰݻ
//	
//	2020.05.28	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂ͓mF
//	
//	
//	
//	
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUP.h"

int		main( int argc, char **argv	)
{

	FILE				*fp;
	char				filename[256];
	unsigned int		size;
	int					i;
	int					pid = 0;
	char				mode[256];
	bool				encrypt = false;
	bool				bitswap = false;

	unsigned char		cmode;

	int					find = 0;
	unsigned short		id;

	struct				usb_bus *busses;
	struct				usb_bus	*bus;
	struct				usb_device	*dev;
	struct				usb_device	*target_dev;
	usb_dev_handle		*handle;

	union UNION_8BYTE	rd;


	struct				timeval	t1, t2;
	long				lapsed_time;
	long				lapsed_sec;
	long				lapsed_usec;


	printf("\nSUPConfig Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Plus Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("example) ./SUPConfig -f./BIN/CX-Card2X_GPIF_Verilog.rbf -mI [-p7206]\n");
	printf("example) ./SUPConfig -f./BIN/SX-Card6_GPIF_Verilog.bin -mX -b [-p7206]\n");
	printf("-f ... BIN/RBF finename.(required)\n");
	printf("-p ... Target ProductID.(optional)\n");
	printf("-m ... Configuration mode.(optional)\n");
	printf("-e ... Encrypt option.(optional)\n");
	printf("-b ... BITSWAP option.(optional)\n\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-f%s", &filename );
		sscanf( argv[i], "-p%x", &pid  );
		sscanf( argv[i], "-m%s", &mode  );

		if(( argv[i][1] == 'e' ) | 	( argv[i][1] == 'E' ))
		{
			encrypt = true;
		}

		if(( argv[i][1] == 'b' ) | 	( argv[i][1] == 'B' ))
		{
			bitswap = true;
		}
	}

	if(( mode[0] == 'I' ) | ( mode[0] == 'i' ))
	{
		cmode = SUP_CONFIG_MODE_INTEL;
	}
	else
	{
		cmode = SUP_CONFIG_MODE_XILINX;
	}


	//	Ұ΂̂܂܏I
	if( argc == 1 )
	{
		//	I
		printf("No Operation ................ DONE!!\n");
		return	false;
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Plus ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Plus ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Plus ... Device not found!!\n" );
		return	false;
	}
	printf("\nConfiguration target %04X:%04X device.\n", target_dev->descriptor.idVendor, target_dev->descriptor.idProduct );

	//	̧ق̊mF
	if(( fp = fopen( filename, "rb" )) == NULL )
	{
		printf("Cannot found [%s]\n\n",filename  );
		return false;
	}
	fclose( fp );


	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Plus Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}
	printf("\n");

	//	-----------------------------------------------------------------------
	//	USB̨ނ̎s
	//	-----------------------------------------------------------------------
	gettimeofday( &t1, NULL );

	if( !SUP_Usb_Config( handle, filename, cmode, bitswap, encrypt ))
	{
		printf("Configuration Failed!!!\n");
	}
	else
	{
		printf("Configuration Successful!!\n");
	}

	gettimeofday( &t2, NULL );
	if( t1.tv_usec > t2.tv_usec )
	{
		t2.tv_usec += 1000000;
		t2.tv_sec--;
	}
	lapsed_sec = ( t2.tv_sec - t1.tv_sec ) * 1000;
	lapsed_usec = ( t2.tv_usec - t1.tv_usec ) / 1000;
	lapsed_time = 	lapsed_sec + lapsed_usec;
	printf("Configuration time = %dms\n", lapsed_time );
	printf("\n\n");

	usb_reset( handle );
	usb_close( handle );
	return	true;
}
