//	----------------------------------------------------------------------------------------------------------------
//	SUP޲plibusbٿĳ ؓ]
//	
//	2020.05.28	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂēmF
//	
//	
//	
//	
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUP.h"

int		main( int argc, char **argv	)
{

	FILE				*fp;
	char				filename[256];
	int					i;
	int					pid = 0;
	unsigned long		read_length;
	unsigned long		write_length;
	int					read = 0;

	int					find = 0;
	unsigned short		id;

	struct				usb_bus *busses;
	struct				usb_bus	*bus;
	struct				usb_device	*dev;
	struct				usb_device	*target_dev;
	usb_dev_handle		*handle;

	struct				timeval	t1, t2;
	long				lapsed_time;
	long				lapsed_sec;
	long				lapsed_usec;


	printf("\nSUPMem Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Plus Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("\nexample) ./SUPMem -f./MEM/Random1_128KB.bin -w20000 [-p8005]\n");
	printf("\nexample) ./SUPMem -f./MEM/Read.bin -r20000 [-p8005]\n");
	printf("-f ... BIN finename.(required)\n");
	printf("-r ... Read acction & read length.(-r20000)\n");
	printf("-w ... Write acction & write length(-w20000)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-f%s", &filename );
		sscanf( argv[i], "-p%x", &pid  );
		sscanf( argv[i], "-r%lx", &read_length );
		sscanf( argv[i], "-w%lx", &write_length );

		if( argv[i][1] == 'r' )
		{
			read = 1;
		}
	}

	//	Ұ΂̂܂܏I
	if( argc == 1 )
	{
		//	I
		printf("No Operation ................ DONE!!\n");
		return	false;
	}


	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Plus ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Plus ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Plus ... Device not found!!\n" );
		return	false;
	}
	printf("\nMEMORY Transfer Target %04X:%04X device.\n", target_dev->descriptor.idVendor, target_dev->descriptor.idProduct );

	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Plus Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	ؓ]s
	//	-----------------------------------------------------------------------
	gettimeofday( &t1, NULL );

	//	Ӱޔ
	if( read )
	{
		printf("MEM READ!!\n");
		printf("Transfer Size = %ld Bytes\n", read_length );
		printf("TARGET FILE = %s\n", filename );
		if( !SUP_Data_Read( handle, filename, read_length, SUP_RANGE_8BIT ))
		{
			printf(" NG!!\n");
			usb_close( handle );
			return	false;
		}
		else
		{
			printf(" OK!!\n");
		}
	}
	else
	{
		//	̧ق̗LmF
		if(( fp = fopen( filename, "rb" )) == NULL )
		{
			printf("Cannot found [%s]\n\n",filename  );
			return false;
		}
		fclose( fp );

		printf("MEM WRITE!!\n");
		printf("Transfer Size = %ld Bytes\n", write_length );
		printf("TARGET FILE = %s\n", filename );
		if( !SUP_Data_Write( handle, filename, write_length, SUP_RANGE_8BIT ))
		{
			printf(" NG!!\n");
			usb_close( handle );
			return	false;
		}
		else
		{
			printf(" OK!!\n");
		}
	}

	gettimeofday( &t2, NULL );
	if( t1.tv_usec > t2.tv_usec )
	{
		t2.tv_usec += 1000000;
		t2.tv_sec--;
	}
	lapsed_sec = ( t2.tv_sec - t1.tv_sec ) * 1000;
	lapsed_usec = ( t2.tv_usec - t1.tv_usec ) / 1000;
	lapsed_time = 	lapsed_sec + lapsed_usec;
	printf("Memory Transfer Time = %dms\n", lapsed_time );

	if( lapsed_time != 0 )
	{
		if( read )
		{
			printf("Transfer Rate = %3.2fMB/s\n", ( float )read_length / ( lapsed_time * 1000l ));
		}
		else
		{
			printf("Transfer Rate = %3.2fMB/s\n", ( float )write_length / ( lapsed_time * 1000l ));
		}
	}
	printf("\n\n");

	usb_close( handle );
	return	true;
}
