//	----------------------------------------------------------------------------------------------------------------
//	SUP޲plibusbٿĳ ڼ޽
//	
//	2020.05.29	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂēmF
//	
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUP.h"

int		main( int argc, char **argv	)
{
	int						i;
	int						pid = 0;
	int						find = 0;
	unsigned short			id;

	unsigned int			adrs = 0;
	unsigned int			length = 0;

	unsigned short			c_adrs;
	unsigned short			c_range;

	unsigned long long		wd, rd;

	unsigned char			read = 0;
	unsigned long long 	 	write = 0;

	struct					usb_bus *busses;
	struct					usb_bus	*bus;
	struct					usb_device	*dev;
	struct					usb_device	*target_dev;
	usb_dev_handle			*handle;

	printf("\nSUPReg Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Plus Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("\nexample) ./SUPReg -wC396 -a4 -l16 [-p8005]\n");
	printf("\nexample) ./SUPReg -r -a2 -l8 [-p8005]\n");
	printf("-p ... Target ProductID.(optional)\n");
	printf("-w ... Write data.(hexadecimal)\n");
	printf("-r ... Read acction.\n");
	printf("-a ... Target register address.(0 to 16383 = 14bit length)\n");
	printf("-l ... Target regster length.(8,16,32,64 bits)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-p%x", &pid );
		sscanf( argv[i], "-l%d", &length );
		sscanf( argv[i], "-w%llx", &write );

		if( argv[i][1] == 'r' )
		{
			read = 1;
		}
	}

	//	sADRSʂsscanfȂƒlرĂ܂
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-a%d", &adrs );
	}

	//	ڽMASK(14ޯ)
	adrs &= 0x3FFF;

	//	ݸ޽mF
	switch( length )
	{
		case	8:	//	8ޯ
					c_range = SUP_RANGE_8BIT;
					write &= 0xFF;
					wd = write;
					break;
		case	16:	//	16ޯ
					c_range = SUP_RANGE_16BIT;
					write &= 0xFFFF;
					wd = write;
					break;
		case	32:	//	32ޯ
					c_range = SUP_RANGE_32BIT;
					write &= 0xFFFFFFFF;
					wd = write;
					break;
		case	64:	//	64ޯ
					c_range = SUP_RANGE_64BIT;
					write &= 0xFFFFFFFFFFFFFFFF;
					wd = write;
					break;
		default:	//	8ޯ
					c_range = SUP_RANGE_8BIT;
					write &= 0xFF;
					wd = write;
					break;
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Plus ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Plus ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}

	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Plus ... Device not found!!\n" );
		return	false;
	}

	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Plus Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	ڼ޽s
	//	-----------------------------------------------------------------------
	printf("\nRegister access target %04X:%04X device.\n", target_dev->descriptor.idVendor, target_dev->descriptor.idProduct );
	printf("Target address : %d\n", adrs );
	printf("Target legth : %d bits\n", length );

	if( read )
	{
		//	ڼ޽ذ
		if( !SUP_Reg_Read( handle, adrs, c_range, &rd ))
		{
			printf("READ NG!!\n");
		}
		else
		{
			printf("READ OK!!\n");
			switch( length )
			{
				case	8:	//	8ޯ
							printf("READ = %02llXh\n", rd );
							break;

				case	16:	//	16ޯ
							printf("READ = %04llXh\n", rd );
							break;

				case	32:	//	32ޯ
							printf("READ = %08llXh\n", rd );
							break;

				case	64:	//	64ޯ
							printf("READ = %016llXh\n", rd );
							break;
				default:	//	8ޯ
							printf("WRITE = %02llXh\n", rd );
							break;
			}
		}
	}
	else
	{
		//	ڼ޽ײ
		if( !SUP_Reg_Write( handle, adrs, c_range, wd ))
		{
			printf("WRITE NG!!\n");
		}
		else
		{
			printf("WRITE OK!!\n");
			switch( length )
			{
				case	8:	//	8ޯ
							printf("WRITE = %02llXh\n", wd );
							break;

				case	16:	//	16ޯ
							printf("WRITE = %04llXh\n", wd );
							break;

				case	32:	//	32ޯ
							printf("WRITE = %08llXh\n", wd );
							break;

				case	64:	//	64ޯ
							printf("WRITE = %016llXh\n", wd );
							break;
				default:	//	8ޯ
							printf("WRITE = %02llXh\n", wd );
							break;
			}
		}
	}

	usb_close( handle );
	return	true;
}
