//	----------------------------------------------------------------------------------------------------------------
//	SUP޲plibusbٿĳ SUSPEND
//	
//	2020.06.03	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂ͓mF
//	
//	
//	
//	
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUP.h"

int		main( int argc, char **argv	)
{

	int					i;
	int					pid = 0;
	char				mode[256];

	int					find = 0;
	unsigned short		id;

	struct				usb_bus *busses;
	struct				usb_bus	*bus;
	struct				usb_device	*dev;
	struct				usb_device	*target_dev;
	usb_dev_handle		*handle;

	unsigned short		suspend;

	printf("\nSUPSuspend Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Plus Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("example) ./SUPSuspend -s0 [-p7206]\n");
	printf("example) ./SUPSuspend -s1 [-p7206]\n");
	printf("-p ... Target ProductID.(optional)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-p%x", &pid  );
		sscanf( argv[i], "-s%s", &mode  );
	}

	if( mode[0] == '0' )
	{
		suspend = 0;
	}
	else
	{
		suspend = 1;
	}

	//	Ұ΂̂܂܏I
	if( argc == 1 )
	{
		//	I
		printf("No Operation ................ DONE!!\n");
		return	false;
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Plus ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Plus ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Plus ... Device not found!!\n" );
		return	false;
	}
	printf("\nConfiguration target %04X:%04X device.\n", target_dev->descriptor.idVendor, target_dev->descriptor.idProduct );

	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Plus Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}
	printf("\n");

	//	-----------------------------------------------------------------------
	//	Ӱސ؂ւ
	//	mode = 1  Ӱނɐ؂ւ
	//	mode = 0  ɰӰނɐ؂ւ
	//	-----------------------------------------------------------------------
	if( !SUP_Suspend( handle, suspend ))
	{
		printf("Failed to switch to SUSPEND mode.\n");
	}
	else
	{
		if( suspend == 0 )
		{
			printf("The switch to NORMAL mode was successful.\n");
		}
		else
		{
			printf("The switch to SUSPEND mode was successful.\n");
		}
	}

	usb_close( handle );
	return	true;
}
